#!/usr/bin/python
# -*- coding: utf-8 -*-

import sip
sip.setapi('QString', 2)
from PyQt4 import QtCore, QtGui
from PyQt4.QtGui import *
from PyQt4.QtCore import *
import sys
import subprocess
import codecs
import unicodedata
from pwd import getpwuid

home_dir = getpwuid(subprocess.os.getuid())[ 5 ]  # адрес домашнего каталога
links=[]  #  список кнопок основной панели (для очистки при переходе на другую страницу)
for x in ['firefox','chromium','opera','vivaldi','kdebase-konqueror']:  # выбор браузера
    q = subprocess.Popen('rpm -q '+x+' > /dev/null 2>&1',shell=True)
    q.wait()
    if q.returncode == 0:
        browser = x
        break 
        
for x in ['gimmage','mirage','gwenview']:  # выбор браузера
    q = subprocess.Popen('rpm -q '+x+' > /dev/null 2>&1',shell=True)
    q.wait()
    if q.returncode == 0:
        viewer = x
        break
if viewer == 'gwenview':
    viewer =  '/usr/lib/kde3/bin/gwenview'         
                                 
# Кнопки для переключения страниц
class But (QPushButton):
    def __init__(self,tx,com,parent): 
        super(But, self).__init__(parent,text=tx)  # создаём кнопку с текстом
        parent.layout.addWidget(self)  # размещаем
        self.setFixedSize(168,33)  # устанавливаем размер               
        self.clicked.connect(com)  # подключаем команду   
        
# Кнопки на страницах
class String (QPushButton):
    def __init__(self,tx,parent,y,w=470,h=25,x=30,com='',hint=''): 
        super(String, self).__init__(parent,text=tx)  # создаём кнопку с текстом      
        self.setGeometry(x,y,w,h)
        self.clicked.connect(com)
        self.show()
        links.append(self)   # для удаления при переходе на другую страницу 
        if hint != '':  # если есть подсказка и велено её показывать, то показываем
            self.setToolTip(u'<table width="250"><tr><td ALIGN=CENTER>'+hint+'</td></tr></table>')                                                      

# Новая страница
class Page ():
    def __init__(self, parent,tx,t,tx_x=30,tx_y=10):
        global main_area
        global links
        root.setWindowTitle(t)  # заголовок страницы
        for butt in links:
            butt.setParent(None)   # удаляем ссылки         
            del butt            
        links = []  # обнуляем список ссылок     
        main_area.setText(tx)
        main_area.setAlignment(Qt.AlignTop)
        main_area.setWordWrap(True)
        main_area.setContentsMargins(tx_x,tx_y,0,0) 
        button_re.hide()               
        button_re.show()
        panel_action.resize(176,213)           
            
def destr(n):  # удаление объекта   
    n.setParent(None)
    n.destroy() 
    
def panel_action_show():
    panel_action.adjustSize()   
    panel_action.show() 

def mpd():
    page = Page(parent=root,tx=u'''Mkimage-profiles-desktop - старый, проверенный временем инструментарий для сборки дистрибутивов на пакетной базе ALT Linux.''',t='Mkimage-profiles-desktop')
    a = String(parent=main_area,tx=u'Руководство по сборке дистрибутивов в Mkimage-profiles-desktop',y=100,com=mpd_help)    

def mp():
    page = Page(parent=root,tx=u'''Mkimage-profiles - более новый, оптимизированный инструментарий для сборки дистрибутивов на пакетной базе ALT Linux.
        
Имеет подробную встроенную справку. Смотрите файлы QUICKSTART в корневом каталоге, файлы README в каталогах и документацию в каталоге doc.''',t='Mkimage-profiles')
    a = String(parent=main_area,tx=u'Корневой каталог Mkimage-profiles',y=150,com=mp_dir)
    s = String(parent=main_area,tx=u'Руководство по Mkimage-profiles',y=190,com=mp_help)           
        
def alterator_mkimage():
    page = Page(parent=root,tx=u'''Alterator-mkimage - модуль Альтератора для сборки дистрибутивов на пакетной базе ALT Linux.''',t='Alterator-mkimage')  
           
def mpgui():
    page = Page(parent=root,tx=u'''Программа mp-gui предназначена для запуска быстрой сборки дистрибутивов из состава mkimage-profiles и, при необходимости, создания локальной копии репозитория пакетов.''',t='Mp-gui')
    a = String(parent=main_area,tx=u'Запуск программы',y=100,com=start_mpgui)
    b = String(parent=main_area,tx=u'Инструкция по использованию',y=140,com=help_mpgui)
    w = String(parent=main_area,tx=u'Обсуждение программы на форуме "Линукс для всех"',y=180,com=forum_mpgui)
        
def navigator():
    page = Page(parent=root,tx=u'''DistroNavigator - графический интерфейс к сборочным системам mkimage-profiles-desktop и mkimage-profiles (первая из них поддерживается полнее, чем вторая). Предназначен преимущественно для новичков. В нём можно собирать 32-битные и 64-битные дистрибутивы на Sisyphus, p7, t7, p6, t6. Запустив программу и подключив репозитории, заходите в "Проекты" - "Новый проект", выбираете один из базовых дистрибутивов, на его основе создаёте свой проект и далее подгоняете его под свои потребности. Когда проект готов, запускаете его сборку. За её ходом можно следить, просматривая журнал.
Программа использует встроенные в неё экземпляры m-p-d и m-p, а потому не зависит от основных m-p-d и m-p, имеющихся в этом дистрибутиве - и, следовательно, не может их поломать. Также она не использует системные настройки для подключения репозиториев (каталог /etc/apt), так что и для них безопасна.
Если желаете оформить собственный дистрибутив по своему вкусу (заставки, слайд-шоу инсталлера), то для этого в программе предназначена секция "Оформление".
Это самые общие сведения. Остальное - в самой программе. На её главной странице кнопка "С чего начать?", ведущая к пошаговым инструкциям и советам. А подсказки по тем или иным конкретным действиям разбросаны по соответствующим страницам программы.''',t='DistroNavigator')
    a = String(parent=main_area,tx=u'Запуск программы',y=360,com=start_navigator)
    w = String(parent=main_area,tx=u'Обсуждение программы на форуме "Линукс для всех"',y=400,com=forum_navigator)
    o = String(parent=main_area,tx=u'Слайд-шоу о программе (старое)',y=440,com=old_slides,hint=u'Слайд-шоу, предназначенное для показа при установке дистрибутивов. Сделано в 2013 году, поэтому там ещё старый вариант Навигатора - да и назывался тот тогда иначе.')
    n = String(parent=main_area,tx=u'Слайд-шоу о программе (новое)',y=480,com=new_slides,hint=u'Новое слайд-шоу, также предназначенное для показа при установке дистрибутивов. Оно пока небольшое, надо дополнить.')
        
def start_navigator():
    subprocess.call('distronavigator &',shell=True)
        
def start_mpgui():
    subprocess.call('mp-gui &',shell=True)
        
def help_mpgui():
    subprocess.call('atril /usr/share/distrohelper/mp-gui.pdf &',shell=True)
        
def mp_dir():
    subprocess.call('spacefm /usr/share/mkimage-profiles &',shell=True)
    
def forum_navigator():
    subprocess.call(browser+' http://forum.russ2.com/index.php?showtopic=3500&view=findpost&p=34056 &',shell=True)
    
def forum_mpgui():
    subprocess.call(browser+' http://forum.russ2.com/index.php?showtopic=4195&view=findpost&p=44079 &',shell=True)
    
def mpd_help():
    subprocess.call(browser+' https://www.altlinux.org/Mkimage/Profiles/Desktop &',shell=True)
    
def mp_help():
    subprocess.call(browser+' https://www.altlinux.org/Mkimage/Profiles/m-p &',shell=True) 
    
def old_slides(): 
    subprocess.call(viewer+' /usr/share/distrohelper/slides_navigator_old/01.png &',shell=True)
    
def new_slides(): 
    subprocess.call(viewer+' /usr/share/distrohelper/slides_navigator_new/01.png &',shell=True)
    
def exit_but():
    exit()
               
# Главная страница
def main_page():                       
    page = Page(parent=root,t=u'Справка по сборочным системам ALT Linux',tx_y=10,tx=u'''Это справка по различным инструментам для сборки собственных дистрибутивов на пакетной базе ALT Linux.
Все они основаны на сборочных системах mkimage-profiles-desktop (m-p-d) и mkimage-profiles (m-p).
Можно использовать их напрямую. То есть подправляете в них файлы, какие нужно, после чего из консоли запускаете сборку. А можно управлять сборочными системами посредством того или иного графического интерфейса.''')   
    button_re.hide()  # скрываем кнопку возврата на главную страницу 
    panel_action.resize(176,178)   

##################### Основа программы #####################

app = QApplication(sys.argv)
app.setFont(QFont('Verdana', 9))
root = QMainWindow() #  создаём окно программы
root.move(150,180)  #  задаём его размеры и расположение на экране
root.setFixedSize(730,540)
main_area = QLabel(root)  #  область пояснительного текста
main_area.setGeometry(10,20,510,520)                                                           
main_area.show()
root.show()
panel_action = QGroupBox(parent=root)  #  панель действий
panel_action.move(550, 110)
panel_action.layout = QVBoxLayout(panel_action)
panel_action.layout.setSpacing(1)
panel_action.layout.setContentsMargins(2,2,2,2)
but_mpd = But(parent=panel_action,tx="Mkimage-profiles-\ndesktop",com=mpd)
but_mp = But(parent=panel_action,tx="Mkimage-\nprofiles",com=mp)
but_alterator_mkimage = But(parent=panel_action,tx="Alterator-\nmkimage",com=alterator_mkimage)    
but_mpgui = But(parent=panel_action,tx="Mp-gui",com=mpgui) 
but_navigator = But(parent=panel_action,tx="DistroNavigator",com=navigator) 
button_re = But (parent=panel_action,tx=u"На главную\nстраницу",com=main_page) # кнопка возврата на главную страницу #(изначально скрыта)   
panel_action.show()
but_exit = QPushButton(parent=root,text=u"Выход")
but_exit.clicked.connect(exit_but)
but_exit.setGeometry(550, 350,168,33)
but_exit.show()
icon_pic = QPixmap() 
icon_pic.load('/usr/share/distrohelper/distrohelper.png')
icon = QIcon(icon_pic)
app.setWindowIcon(icon)
app.setStyleSheet(" QMainWindow {background: qlineargradient(x1:0, y1:0, x2:1, y2:1,stop:0 '#edfcd8',  stop:1 '#e9fbd5') } QPushButton {background-color:'#cbf6af' } QPushButton:hover { background-color:'#9de9a8' } String {border:0px;  background-color:'#d5f5a6' } String:hover { background-color: '#b8f8b1' } ")
main_page()   
sys.exit(app.exec_())
